/**
 * 
 */
package sample;

import java.sql.Timestamp;
import java.util.Date;

import javax.jdo.annotations.IdGeneratorStrategy;
import javax.jdo.annotations.IdentityType;
import javax.jdo.annotations.NotPersistent;
import javax.jdo.annotations.PersistenceCapable;
import javax.jdo.annotations.Persistent;
import javax.jdo.annotations.PrimaryKey;

/**
 * @author kita
 *
 */
@PersistenceCapable(identityType = IdentityType.APPLICATION, detachable="true") 
public class Address {

	private static final long serialVersionUID = -2856548504676361413L;
	@PrimaryKey 
    @Persistent(valueStrategy = IdGeneratorStrategy.IDENTITY) 
	private Long id;
    @Persistent 
	private String lastNameFurigana;
    @Persistent 
	private String firstNameFurigana;
    @Persistent 
	private String lastName;
    @Persistent 
	private String firstName;
    @Persistent 
	private String mail;
    @Persistent 
	private String phone;
    @Persistent 
	private String mobilePhone;
    @Persistent 
	private Date timestamp;
	
    @NotPersistent 
	public String idString;
    @NotPersistent 
	public boolean checkbox;

    public Address(){};
	/**
	 * RXgN^
	 * @param lastNameFurigana
	 * @param firstNameFurigana
	 * @param lastName
	 * @param firstName
	 * @param mail
	 * @param phone
	 * @param mobilePhone
	 */
	public Address(String lastNameFurigana, String firstNameFurigana, String lastName, String firstName, String mail, String phone, String mobilePhone) {
		this.lastNameFurigana = lastNameFurigana;
		this.firstNameFurigana = firstNameFurigana;
		this.lastName = lastName;
		this.firstName = firstName;
		this.mail = mail;
		this.phone = phone;
		this.mobilePhone = mobilePhone;
	}

	/**
	 * tl[擾B
	 * @return tl[
	 */
	public String getFullName() {
		return lastName + " " + firstName;
	}
	
	/**
	 * 擾B
	 * @return firstName
	 */
	public String getFirstName() {
		return firstName;
	}

	/**
	 * ݒ肷B
	 * @param firstName
	 */
	public void setFirstName(String firstName) {
		this.firstName = firstName;
	}
	
	/**
	 * ӂ肪ȁij擾B
	 * @return firstNameFurigana
	 */
	public String getFirstNameFurigana() {
		return firstNameFurigana;
	}
	
	/**
	 * ӂ肪ȁijݒ肷B
	 * @param firstNameFurigana
	 */
	public void setFirstNameFurigana(String firstNameFurigana) {
		this.firstNameFurigana = firstNameFurigana;
	}
	
	/**
	 * ID擾B
	 * @return id
	 */
	public Long getId() {
		return id;
	}
	
	/**
	 * IDݒ肷B
	 * @param id
	 */
	public void setId(Long id) {
		this.id = id;
	}
	
	/**
	 * 擾B
	 * @return lastName
	 */
	public String getLastName() {
		return lastName;
	}
	
	/**
	 * ݒ肷B
	 * @param lastName
	 */
	public void setLastName(String lastName) {
		this.lastName = lastName;
	}
	
	/**
	 * ӂ肪ȁij擾B
	 * @return lastNameFurigana
	 */
	public String getLastNameFurigana() {
		return lastNameFurigana;
	}
	
	/**
	 * ӂ肪ȁijݒ肷B
	 * @param lastNameFurigana
	 */
	public void setLastNameFurigana(String lastNameFurigana) {
		this.lastNameFurigana = lastNameFurigana;
	}
	
	/**
	 * gѓdbԍ擾B
	 * @return mobilePhone
	 */
	public String getMobilePhone() {
		return mobilePhone;
	}

	/**
	 * gѓdbԍݒ肷B
	 * @param mobilePhone
	 */
	public void setMobilePhone(String mobilePhone) {
		this.mobilePhone = mobilePhone;
	}
	
	/**
	 * dbԍ擾B
	 * @return phone
	 */
	public String getPhone() {
		return phone;
	}
	
	/**
	 * dbԍݒ肷B
	 * @param phone
	 */
	public void setPhone(String phone) {
		this.phone = phone;
	}
	
	/**
	 * ^CX^v擾B
	 * @return timestamp
	 */
	public Date getTimestamp() {
		return timestamp;
	}
	
	/**
	 * ^CX^vݒ肷B
	 * @param timestamp
	 */
	public void setTimestamp(Date timestamp) {
		this.timestamp = timestamp;
	}

	/**
	 * [AhX擾B
	 * @return mail
	 */
	public String getMail() {
		return mail;
	}

	/**
	 * [AhXݒ肷B
	 * @param mail
	 */
	public void setMail(String mail) {
		this.mail = mail;
	}
	/**
	 * @return the idString
	 */
	public String getIdString() {
		return idString;
	}
	/**
	 * @param idString the idString to set
	 */
	public void setIdString(String idString) {
		this.idString = idString;
	}
	/**
	 * @return the checkbox
	 */
	public boolean isCheckbox() {
		return checkbox;
	}
	/**
	 * @param checkbox the checkbox to set
	 */
	public void setCheckbox(boolean checkbox) {
		this.checkbox = checkbox;
	}

	
}
