/**
 * 
 */
package sample;

import java.util.HashMap;
import java.util.List;

import javax.jdo.PersistenceManager;

import jp.oarts.pirka.core.kernel.FieldMap;
import jp.oarts.pirka.core.win.PirkaWindow;

/**
 * @author kita
 *
 */
public class AddressBookList extends PirkaWindow{
	/**
	 * 
	 */
	private static final long serialVersionUID = 8675369191747578781L;
	/**
	 * f[^ێ
	 */
	private HashMap<Long, Address> dataMap;
	
	/**
	 * RXgN^
	 */
	public AddressBookList() {
		dataMap = new HashMap<Long, Address>();
	}
	
	/**
	 * `O
	 */
	public void preDraw() {

		reload();
	}
	
	/**
	 * ێf[^XVB
	 * @param list
	 */
	private void renewDataMap(List<Address> list) {
		dataMap.clear();
		for (int i=0;i<list.size();i++) {
			Address address = (Address)list.get(i);
			dataMap.put(address.getId().longValue(), address);
		}
	}
	
	/**
	 * ǉ
	 * @return o^ҏW
	 */
	public PirkaWindow add() {
		return new NewAddressBook(null);
	}

	/**
	 * ҏW
	 * @return o^ҏW
	 */
	public PirkaWindow edit() {
		PirkaWindow result = null;
		FieldMap map = getFieldMap();
		for (int ii = 0; ii < map.getFieldMapSize("loop"); ii++) {
			FieldMap line = map.getFieldMap("loop", ii);
			if (line.getValueBoolean("checkbox")) {
				Address target = dataMap.get(line.getValueLong("id"));
				if (target != null) {
					result = new NewAddressBook(target);
					break;
				}
			}
		}
		return result;
	}

	/**
	 * 폜
	 */
	public void delete() {
	    PersistenceManager pm = PMF.get().getPersistenceManager(); 
		FieldMap map = getFieldMap();
		try{
			for (int ii = 0; ii < map.getFieldMapSize("loop"); ii++) {
				FieldMap line = map.getFieldMap("loop", ii);
				if (line.getValueBoolean("checkbox")) {
					Address target = dataMap.get(line.getValueLong("id"));
					if (target != null) {
						Address adr = pm.getObjectById(Address.class, target.getId());
						pm.deletePersistent(adr);
					}
				}
			}
	
		} finally { 
		    pm.close(); 
		} 
	}

	/**
	 * ēǍ
	 */
	public void reload() {
		// preDrawōĕ`
	    FieldMap map = getFieldMap();
		map.clearFieldMap("loop");

		PersistenceManager pm = PMF.get().getPersistenceManager(); 
	    pm.setDetachAllOnCommit(true); 
		try{
			String query = "select from " + Address.class.getName(); 
		    List<Address> list = (List<Address>) pm.newQuery(query).execute(); 
		    if (list.isEmpty()) { 
		    	/// ̃bZ[W
		    }else{
				renewDataMap(list);
				setBeanList(list, map, "loop");
		    }
		} finally { 
		    pm.close(); 
		} 
	}

}
